/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem.region;

import lombok.Getter;
import lombok.RequiredArgsConstructor;

@RequiredArgsConstructor
@Getter
public enum RegionType {

    GLOBAL(true, false, true, ConnectionType.Global),
    /**
     * This should not be used by the DynamicRegionSystem
     */
    NORMAL(false, true, false, ConnectionType.Closed),

    SPAWN(false, false, true, ConnectionType.Closed),
    SPAWN_PATH(false, false, true, ConnectionType.Path),
    SPAWN_EXTENSION(false, false, false, ConnectionType.Closed),
    PATH(false, false, false, ConnectionType.Path),
    DRY(false, true, false, ConnectionType.Closed),
    DRY_SPECIAL(false, false, false, ConnectionType.Closed),
    WET(false, true, false, ConnectionType.Water),
    WET_SPECIAL(false, false, false, ConnectionType.Water),
    ;

    private final boolean global;
    private final boolean createBackup;
    private final boolean cannotDelete;
    private final ConnectionType connectionType;

    public enum ConnectionType {
        Closed,
        Path,
        Water,
        Global
    }
}
